// Switch LEDs on all 20 GPIOs of an Arduino Uno
// Details about connecting LEDs to the pins on:
// http://homofaciens.de/technics-physical-computing-switching-LEDs_en.htm


int i;

// Define pause in milliseconds 1s = 1000ms
#define LED_PAUSE 500

// The setup routine runs once when you turn on the Arduino
// or whenever you press the reset button on the board:
void setup() {
  // initialize all GPIOs as output.
  for(i=0; i<20; i++){
    pinMode(i, OUTPUT);
  }
}

// the loop routine runs over and over again forever:
void loop() {
  delay(3000); //do nothing for 3 seconds
  // Turn all LEDs ON in sequence
  for(i=0; i<20; i++){
    digitalWrite(i, HIGH);   // turn LED ON (HIGH is the voltage level)
    delay(LED_PAUSE);        // wait LED_PAUSE milliseconds
  }
  delay(3000); //do nothing for 3 seconds
  // Turn all LEDs OFF for LED_PAUSE milliseconds
  for(i=0; i<20; i++){
    digitalWrite(i, LOW);    // turn LED OFF by making the voltage LOW
    delay(LED_PAUSE);        // wait LED_PAUSE milliseconds
    digitalWrite(i, HIGH);   // turn LED ON
    delay(LED_PAUSE);        // wait LED_PAUSE milliseconds
  }
  delay(3000); //do nothing for 3 seconds
  // Turn all LEDs OFF in sequence
  for(i=0; i<20; i++){
    digitalWrite(i, LOW);    // turn the LED OFF
    delay(LED_PAUSE);        // wait LED_PAUSE milliseconds
  }
}
